# FileIOProcessData

### SetDataAsCSV

Set the file data to the bytes of a CSV and change the MIME type to CSV.

#### Example:

```csharp
data.SetDataAsCSV("id,name\n1,John Doe");
```

### SetDataAsJson

Set the file data to the bytes of JSON and change the MIME type to JSON.

#### Example:

```csharp
data.SetDataAsJson("{\"id\":1,\"name\":\"John Doe\"}");
```

### SetAsDataTable

Remove the file bytes and set a parsed data table.

#### Example:

```csharp
data.SetAsDataTable(new DataTable());
```

### GetEncoding

Retrieve the file encoding.

#### Example:

```csharp
Encoding encoding = data.GetEncoding;
```

### BytesToString

Convert the bytes to a string using the detected encoding from `GetEncoding`.

#### Example:

```csharp
string fileContent = data.BytesToString();
```

### TableFromFile

A helper function to get a table from a byte array and MIME type, or if the data table has been assigned, it is returned instead.

#### Example:

```csharp
DataTable dataTable = data.TableFromFile();
```

### GetConfiguration

Get a configuration value, even if it is encrypted. This method allows you to read configurations when writing plugins for the TransformClient Automation application.

#### Parameters:

* `key`: Key of the value (e.g., "AppSettings:MyAPIKey").

#### Example:

```csharp
string configValue = data.GetConfiguration("AppSettings:MyAPIKey");
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.perigee.software/transform-sdk/sdk-reference/fileioprocessdata.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
